package io.zipcoder.interfaces;

import java.lang.reflect.Array;
import java.util.ArrayList;

public abstract class People<E extends Person> {
    ArrayList<E> personList = new ArrayList<E>();

    public void add(E person) {
        personList.add(person);
    }

    public int getCount() {
        return personList.size();
    }

    public void remove(E person) {
        personList.removeIf(E -> E.equals(person));
    }

    public void remove(long i) {
        personList.removeIf(E -> E.getID() == i);
    }

    public E findByID(long id) {
        E personToFind = null;
        for (E person : personList) {
            if (person.getID() == id) {
                personToFind = person;
            }
        }
        return personToFind;
    }


    public abstract E[] getArray();
//        return personList.toArray(new Person[getCount()]);


    public void removeAll() {
        personList.removeAll(personList);
    }
}