package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class PeopleTest {

    Students people;

    @Before public void setup() {
        people = Students.getInstance();
    }

    @Test public void testAdd() {
        Student person = new Student(1);
        people.personList.add(person);

        Assert.assertNotNull(people.personList.get(0));
    }

    @Test public void testAdd2() {
        Student one = new Student(1);
        Student two = new Student(2);

        people.personList.add(one);
        people.personList.add(two);

        int actual = people.getCount();
        int expected = 2;

        Assert.assertEquals(expected,actual);
    }

    @Test public void testRemoveByStudent() {
        Student one = new Student(1);
        Student two = new Student(2);
        Student three = new Student(3);

        people.personList.add(one);
        people.personList.add(two);
        people.personList.add(three);

        int before = people.getCount();
        people.remove(two);
        int after = people.getCount();

        Assert.assertEquals(1, before-after);
    }

    @Test public void testRemoveByID() {
        Student one = new Student(1);
        Student two = new Student(2);
        Student three = new Student(3);

        people.personList.add(one);
        people.personList.add(two);
        people.personList.add(three);

        int before = people.getCount();
        people.remove(2);
        int after = people.getCount();

        Assert.assertEquals(1, before-after);
    }

    @Test public void testFindByID() {
        Student one = new Student(1);
        Student two = new Student(2);
        Student three = new Student(3);

        people.personList.add(one);
        people.personList.add(two);
        people.personList.add(three);

        Student actual = people.findByID(2);
        Student expected = two;

        Assert.assertEquals(expected, actual);
    }

    @Test public void testGetArray() {
        Student one = new Student(1);
        Student two = new Student(2);
        Student three = new Student(3);

        people.personList.add(one);
        people.personList.add(two);
        people.personList.add(three);

        Student[] personArray = people.getArray();
        boolean allAccountedFor = true;

        for (int i = 0; i < personArray.length; i++) {
            if (personArray[i] != people.personList.get(i)) {
                allAccountedFor = false;
            }
        }

        Assert.assertTrue(allAccountedFor);
    }

    @Test public void testRemoveAll() {
        Student one = new Student(1);
        Student two = new Student(2);
        Student three = new Student(3);

        people.personList.add(one);
        people.personList.add(two);
        people.personList.add(three);

        people.removeAll();

        Assert.assertTrue(people.getCount() == 0);
    }

}
